import type { H3Event } from 'h3';
import type { GraphqlMiddlewareRequestContext } from '../../types.js';
import type { GraphqlMiddlewareOperation } from '../../settings/index.js';
type RequestBody = {
    query: string;
    variables?: Record<string, any>;
    operation?: GraphqlMiddlewareOperation;
    operationName?: string;
};
/**
 * Perform a raw GraphQL request.
 *
 * @param body - The request.
 * @param context - The client context.
 * @param event - The H3 event. If not provided, the util will try to get the event using useEvent().
 */
export declare function doGraphqlRequest(body: RequestBody, context?: GraphqlMiddlewareRequestContext | null | undefined, providedEvent?: H3Event | null | undefined): Promise<any>;
export {};
